#include "gd32f10x.h"
#include "fmc.h"


/*-------------------------------------------------*/
/*FLASH                                */
/*  startʼ   num    */
/*ֵ                                       */
/*-------------------------------------------------*/
void GD32_EraseFlash(uint16_t start, uint16_t num)
{
	uint16_t i;        //forѭ

	fmc_unlock();                                                       //
	for(i=0;i<num;i++){                                                 //ѭnumΣһһĲ
		fmc_page_erase((0x08000000 + start * 1024) + (1024 * i));       //һ
	}
	fmc_lock();                                                         //
} 
/*---------------------------------------------------------------------*/
/*дFLASH                                                    */
/*  saddrдַ wdataдָ  wnumдٸֽ    */
/*ֵ                                                           */
/*---------------------------------------------------------------------*/
void GD32_WriteFlash(uint32_t saddr, uint32_t *wdata, uint32_t wnum)
{
	fmc_unlock();                          //
	while(wnum){                           //ѭд룬֪num0˳whileʾд
		fmc_word_program(saddr,*wdata);    //дһ֣4ֽڣ
		wnum-=4;                           //дֽ-4
		saddr+=4;                          //дַ+4
		wdata++;                           //дݵָ룬Ųһ
	}
	fmc_lock();                            //
}



/**
 * FLASH
 * @param  Address ַ
 * @param  Buffer  Ŷȡ
 * @param  Size    ҪȡݴСλֽ
 * @return         ɹֽ
 */
uint32_t FLASH_Read(uint32_t Address, void *Buffer, uint32_t Size)
{
    uint32_t nread = Size;
    uint8_t* d = (uint8_t *)Buffer;
    const uint8_t* s = (const uint8_t *)Address;

    if (!Buffer || Address < GD32FLASH_BASE || Address >= GD32FLASH_END)
        return 0;

    while (nread >= sizeof(uint32_t) && (((uint32_t)s) <= (GD32FLASH_END - 4)))
    {
        *(volatile uint32_t *)d = *(volatile uint32_t *)s;
        d += sizeof(uint32_t);
        s += sizeof(uint32_t);
        nread -= sizeof(uint32_t);
    }

    while (nread && (((uint32_t)s) < GD32FLASH_END))
    {
        *d++ = *s++;
        nread--;
    }

    return Size - nread;
}

