#ifndef FMC_H
#define FMC_H

#include "stdint.h"

void GD32_EraseFlash(uint16_t start, uint16_t num);                     //
void GD32_WriteFlash(uint32_t saddr, uint32_t *wdata, uint32_t wnum);   //



#include "gd32f10x.h"

/// ֲ޸ ///

/* FLASHС3MB */
#define GD32FLASH_SIZE  0X00300000UL

/* FLASHʼַ */
#define GD32FLASH_BASE  FLASH_BASE

/* FLASHַ */
#define GD32FLASH_END   (GD32FLASH_BASE | GD32FLASH_SIZE)

/* FALSHҳС */
#define GD32FLASH_PAGE_SIZE 1024

/* FLASHҳ */
#define GD32FLASH_PAGE_NUM  (GD32FLASH_SIZE / GD32FLASH_PAGE_SIZE)

///  
uint32_t FLASH_Read(uint32_t Address, void *Buffer, uint32_t Size);

#endif



